import java.lang.reflect.Array;
import java.time.LocalDate;
import java.util.*;
import java.util.stream.Collectors;
import java.util.stream.Stream;

public class GenericAccount<T extends AccountBook> {
    private List<T> transactions;

    Payee owner;
    double cashAmount;

    GenericAccount(){
        new GenericAccount<>(0);
    }

    GenericAccount(double cashAmount){
        new GenericAccount<>(new Payee(),cashAmount);
    }

    GenericAccount(Payee owner, double cashAmount){
        this.owner = owner;
        this.cashAmount = cashAmount;
        transactions = new ArrayList<>();
    }

    public boolean add(T element){
        return transactions.add(element);
    }

    public int size(){
        return transactions.size();
    }

    public boolean isEmpty(){
        return transactions.isEmpty();
    }

    public boolean contains(T element){
        return transactions.contains(element);
    }

    public boolean remove(T element){
        return transactions.remove(element);
    }

    public Iterator<T> iterator(){
        return transactions.iterator();
    }

    public T[] toArray(){
        Class clazz = transactions.get(0).getClass();
        T[] array = (T[]) Array.newInstance(clazz,size());
        for (int i=0; i<array.length; i++)
            array[i] = transactions.get(i);
        return array;
    }

    public T[] toArray(T[] array){
        return transactions.toArray(array);
    }

    public double checkbookValue(){
        return transactions.stream().mapToDouble(T::getAmount).sum();
    }

    public T[] getTransactionsForDate(LocalDate aDate){
        long sum = transactions.stream().filter(e -> e.getDate().equals(aDate)).count();
        Class clazz = transactions.get(0).getClass();
        T[] array = (T[]) Array.newInstance(clazz,(int) sum);
        for (int i=0; i<array.length; i++)
            array[i] = transactions.get(i);
        return array;
    }

    public boolean containsAll(Collection c){
        return transactions.containsAll(c);
    }

    public boolean addAll(Collection c){
        return transactions.addAll(c);
    }

    public boolean removeAll(Collection c){
        return transactions.removeAll(c);
    }

    public void clear(){
        transactions.clear();
    }
}
